/*+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

                                        S P I N N E R

Voir le Manuel d'Utilisation dans spinner_help.htm

Ce code est proprit de Patrick RENAUD (patrick.renaud@nomade.fr)

Versions :

  1.0.0     19/07/2002      - cration

  2.0.0     17/08/2002      - possibilit de passage des arguments par paramtres nomms
                              (le passage par paramtres positionnels fonctionne aussi)
                            - ajout argument "step" pour incrment diffrent de 1
                            - ajout argument "precision" pour affichage avec nombre de dcimales fixe

  2.1.0     14/09/2002      - ajout fonction possibilit de modifier les bornes par setSpinner
                            - ajout argument "callback" dans fonction addSpinner pour excution d'une 
                              fonction utilisateur sur changement de la valeur

+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=*/

//########################################################################################  
// Variables globales                           
//########################################################################################  

var glbSpinnerDir = '';

//########################################################################################  
// Fonction initSpinner
// 
// Init des ressources globales
// 
// initSpinner(repertoire du fichier spinner.js (ou '.' si dans le mme rpertoire));
// 
//########################################################################################  

function initSpinner(spinnerDir)
{
  //============================================  
  // Memorisation du chemin pour la modif         
  // des images "up" et "down"                    
  //============================================  

  if ( spinnerDir == null )
    glbSpinnerDir = '.';
  else
    glbSpinnerDir = spinnerDir;

  //============================================  
  // Pr-chargement des images dans le cache      
  // du navigateur                                
  //============================================  

  document.img1 = new Image;
  document.img1.src = glbSpinnerDir + "/spinner_down.gif";
  document.img2 = new Image;
  document.img2.src = glbSpinnerDir + "/spinner_down_click.gif";
  document.img3 = new Image;
  document.img3.src = glbSpinnerDir + "/spinner_up.gif";
  document.img4 = new Image;
  document.img4.src = glbSpinnerDir + "/spinner_up_click.gif";
}

//########################################################################################  
// Fonction addSpinner
// 
// Ajout d'un nouveau spinner
// 
// addSpinner(
//    "name" , nom du spinner,
//    "width" , taille de la zone de saisie (3 par dfaut),
//    "default" , valeur par dfaut (0 par dfaut),
//    "min" , valeur min (quelconque si pas de min),
//    "max" , valeur max (= min si pas de max),
//    "roll" , indicateur de circularit si min != max (0 ou "no" (dfaut) = pas circulaire , 1 ou "yes" = circulaire)
//    "position" , position des flches ('left' ou 'right' (par dfaut)),
//    "timeout" , temps de modif si le bouton reste enfonc (200 ms par dfaut)
//    "step" , valeur d'incrment (1 par dfaut),
//    "callback" , code excut lorsque la valeur change,
//    "precision" , nombre de chiffres aprs la virgule (0 par dfaut = nombre entier , -1 = pas de limite),
// );
// 
//########################################################################################  

function addSpinner()
{
  //============================================  
  // Test si init a t faite                     
  //============================================  

  if ( glbSpinnerDir == '' )
  {
    alert("Spinners non initialiss.\n\nAppelez la fonction initSpinner(repertoire);");
    return;
  }

  //============================================  
  // Dclaration variables                        
  //============================================  

  var spinnerName;
  var spinnerWidth = 3;
  var spinnerDefault = 0;
  var spinnerStep = 1;
  var spinnerPrecision = 0;
  var spinnerMin = 0;
  var spinnerMax = 0;
  var spinnerRoll = 'no';
  var spinnerPosition = 'right';
  var spinnerTimeout = 200;
  var spinnerCallback = "";

  //============================================  
  // Lecture arguments                            
  //============================================  

  if ( arguments[0] == "name" || arguments[0] == "width" || arguments[0] == "default" || arguments[0] == "min" || arguments[0] == "max" || arguments[0] == "roll" || arguments[0] == "position" || arguments[0] == "timeout" || arguments[0] == "step" || arguments[0] == "precision" )
  {
    //============================================  
    // Arguments nomms                             
    //============================================  

    for (var i=0; i<arguments.length; i++) 
    {
      switch ( arguments[i] )
      {
        case "callback" :
          spinnerCallback = arguments[++i];
          break;
        case "name" :
          spinnerName = arguments[++i];
          break;
        case "width" :
          spinnerWidth = arguments[++i];
          break;
        case "min" :
          spinnerMin = arguments[++i];
          break;
        case "max" :
          spinnerMax = arguments[++i];
          break;
        case "roll" :
          spinnerRoll = arguments[++i];
          break;
        case "default" :
          spinnerDefault = arguments[++i];
          break;
        case "step" :
          spinnerStep = arguments[++i];
          break;
        case "timeout" :
          spinnerTimeout = arguments[++i];
          break;
        case "position" :
          spinnerPosition = arguments[++i];
          break;
        case "precision" :
          spinnerPrecision = arguments[++i];
          break;
        default :
          alert("addSpinner : argument non reconnu : " + arguments[i]);
          return;
          break;
      }
    }
  }
  else
  {
    //============================================  
    // Arguments positionnels
    //============================================  

    spinnerName = arguments[0];
    spinnerWidth = arguments[1];
    spinnerDefault = arguments[2];
    spinnerMin = arguments[3];
    spinnerMax = arguments[4];
    spinnerRoll = arguments[5];
    spinnerPosition = arguments[6];
    spinnerTimeout = arguments[7];
    spinnerStep = arguments[8];
    spinnerPrecision = arguments[9];
  }

  //============================================  
  // Valeur par defaut des paramtres             
  //============================================  

  if ( String(spinnerName) == 'undefined' )
  {
    alert("addSpinner : un nom DOIT tre fourni");
    return;
  }

  if ( isNaN(parseInt(spinnerWidth)) )
    spinnerWidth = 3;

  if ( isNaN(parseInt(spinnerPrecision)) )
    spinnerPrecision = 0;

  if ( isNaN(parseFloat(spinnerDefault)) )
    spinnerDefault = 0;

  if ( isNaN(parseFloat(spinnerMin)) )
    spinnerMin = 0;

  if ( isNaN(parseFloat(spinnerMax)) )
    spinnerMax = 0;

  if ( isNaN(parseFloat(spinnerStep)) )
    spinnerStep = 1;

  if ( spinnerRoll == "yes" )
    spinnerRoll = 1;
  if ( isNaN(parseInt(spinnerRoll)) || spinnerRoll == "no" )
    spinnerRoll = 0;

  if ( String(spinnerPosition) == 'undefined' )
    spinnerPosition = 'right';

  if ( isNaN(parseInt(spinnerTimeout)) || spinnerTimeout < 200 )
    spinnerTimeout = 200;

  //============================================  
  // Ajustement valeur initiale                   
  //============================================  

  var defaultStr = String(spinnerDefault);
  if ( spinnerPrecision == 0 )
  {
    defaultStr = String(Math.round(spinnerDefault));
  }
  else if ( spinnerPrecision > 0 )
  {
    var coef = Math.pow(10,spinnerPrecision);
    var value = Math.round(spinnerDefault*coef)/coef;
    defaultStr = String(value);
    if ( defaultStr.indexOf(".") == -1 )
    {
      defaultStr = defaultStr + ".0";
    }
    var nb = spinnerPrecision - (defaultStr.length - defaultStr.indexOf(".") - 1);
    defaultStr = defaultStr + "00000000000000000000".substr(0,nb);
    defaultStr = defaultStr.replace(".",",");
  }

  //============================================  
  // Creation du code du spinner                  
  //============================================  

  document.writeln('<form name="' + spinnerName + '">');
  document.writeln('<script language="JavaScript">');
  document.writeln('<!--');

  //============================================  
  // Creation du javaScript de gestion            
  //============================================  

  document.writeln('var spinnerValue_' + spinnerName + ' = ' + spinnerDefault + ';');
  document.writeln('var spinnerMin_' + spinnerName + ' = ' + spinnerMin + ';');
  document.writeln('var spinnerMax_' + spinnerName + ' = ' + spinnerMax + ';');
  document.writeln('var spinnerImg_' + spinnerName + ';');
  document.writeln('var spinnerTimeout_' + spinnerName + ';');
  document.writeln('var spinnerCallback_' + spinnerName + ' = new Function("' + spinnerCallback + '");');
  document.writeln('');

  //============================================  
  // Fonction de mise en forme de la valeur
  //============================================  

  document.writeln('function spinnerAdjust_' + spinnerName + '(value)');
  document.writeln('{');
  document.writeln('  value = parseFloat(value) + 0;');
  if ( spinnerPrecision == 0 )
  {
    document.writeln('  return Math.round(value);');
  }
  else if ( spinnerPrecision < 0 )
  {
    document.writeln('  var str = String(value);');
    document.writeln('  return str.replace(".",",");');
  }
  else
  {
    document.writeln('  var coef = Math.pow(10,' + spinnerPrecision + ');');
    document.writeln('  value = Math.round(value*coef)/coef;');
    document.writeln('  var str = String(value);');
    document.writeln('  str = str.replace(".",",");');
    document.writeln('  if ( str.indexOf(",") == -1 )');
    document.writeln('  {');
    document.writeln('    str = str + ",0";');
    document.writeln('  }');
    document.writeln('  var nb = ' + spinnerPrecision + ' - (str.length - str.indexOf(",") - 1);');
    document.writeln('  return str + "00000000000000000000".substr(0,nb);');
  }
  document.writeln('}');

  //============================================  
  // Fonction appele sur changement direct       
  // de la valeur (saisie dans la zone)           
  //============================================  

  document.writeln('function spinnerChange_' + spinnerName + '()');
  document.writeln('{');
  document.writeln('  var val = document.forms["' + spinnerName + '"].INPUT.value;');
  document.writeln('  var min = document.forms["' + spinnerName + '"].MIN.value;');
  document.writeln('  var max = document.forms["' + spinnerName + '"].MAX.value;');
  document.writeln('  val = val.replace(",",".");');
  document.writeln('  if ( isNaN(val) )');
  document.writeln('  {');
  document.writeln('    alert("' + spinnerName + ' : la chane saisie (" + val + ") n\'est pas un nombre");');
//  document.writeln('    document.forms["' + spinnerName + '"].INPUT.value = spinnerValue_' + spinnerName + ';');
  document.writeln('    val = spinnerValue_' + spinnerName + ';');
  document.writeln('    document.forms["' + spinnerName + '"].INPUT.focus();');
  document.writeln('  }');
  document.writeln('  val = parseFloat(val);');
  document.writeln('  if ( min == max || (val < min || val > max) )');
  document.writeln('  {');
  document.writeln('    alert("' + spinnerName + ' : la valeur saisie (" + val + ") est hors des bornes autorises (" + min + "  " + max + ")");');
//  document.writeln('    document.forms["' + spinnerName + '"].INPUT.value = spinnerValue_' + spinnerName + ';');
  document.writeln('    val = spinnerValue_' + spinnerName + ';');
  document.writeln('    document.forms["' + spinnerName + '"].INPUT.focus();');
  document.writeln('  }');
  document.writeln('  else');
  document.writeln('  {');
  document.writeln('    spinnerValue_' + spinnerName + ' = val;');
  document.writeln('  }');
  document.writeln('  document.forms["' + spinnerName + '"].INPUT.value = spinnerAdjust_' + spinnerName + '(val);');
  document.writeln('  spinnerCallback_' + spinnerName + '();');
  document.writeln('}');
  document.writeln('');
  
  //============================================  
  // Fonction appele par le timeout de repetition
  //============================================  

  document.writeln('function spinnerRepeat_' + spinnerName + '()');
  document.writeln('{');
  document.writeln('    spinnerDown_' + spinnerName + '(spinnerImg_' + spinnerName + ');');
  document.writeln('}');

  //============================================  
  // Fonction appele quand un des boutons
  // est appuy                                   
  //============================================  

  document.writeln('function spinnerDown_' + spinnerName + '(img)');
  document.writeln('{');
  document.writeln('  var val = document.forms["' + spinnerName + '"].INPUT.value;');
  document.writeln('  var min = document.forms["' + spinnerName + '"].MIN.value;');
  document.writeln('  var max = document.forms["' + spinnerName + '"].MAX.value;');
  document.writeln('  val = val.replace(",",".");');
  document.writeln('  val = parseFloat(val) + 0;');
  document.writeln('  spinnerImg_' + spinnerName + ' = img;');
  document.writeln('  var action = img.src;');
  document.writeln('  if ( action.indexOf("spinner_up") >= 0 )');
  document.writeln('  {');
  document.writeln('    img.src = "' + glbSpinnerDir + '/spinner_up_click.gif";');
  document.writeln('    val += ' + spinnerStep + ';');
  document.writeln('    if ( min == max || val <= max )');
  document.writeln('    {');
  document.writeln('      spinnerValue_' + spinnerName + ' = val;');
  document.writeln('      document.forms["' + spinnerName + '"].INPUT.value = spinnerAdjust_' + spinnerName + '(val);');
  document.writeln('    }');
  if ( spinnerRoll )
  {
    document.writeln('    else');
    document.writeln('    {');
    document.writeln('      val = min;');
    document.writeln('      spinnerValue_' + spinnerName + ' = val;');
    document.writeln('      document.forms["' + spinnerName + '"].INPUT.value = spinnerAdjust_' + spinnerName + '(val);');
    document.writeln('    }');
  }
  document.writeln('  }');
  document.writeln('  else if ( action.indexOf("spinner_down") >= 0 )');
  document.writeln('  {');
  document.writeln('    img.src = "' + glbSpinnerDir + '/spinner_down_click.gif";');
  document.writeln('    val -= ' + spinnerStep + ';');
  document.writeln('    if ( min == max || val >= min )');
  document.writeln('    {');
  document.writeln('      spinnerValue_' + spinnerName + ' = val;');
  document.writeln('      document.forms["' + spinnerName + '"].INPUT.value = spinnerAdjust_' + spinnerName + '(val);');
  document.writeln('    }');
  if ( spinnerRoll )
  {
    document.writeln('    else');
    document.writeln('    {');
    document.writeln('      val = max;');
    document.writeln('      spinnerValue_' + spinnerName + ' = val;');
    document.writeln('      document.forms["' + spinnerName + '"].INPUT.value = spinnerAdjust_' + spinnerName + '(val);');
    document.writeln('    }');
  }
  document.writeln('  }');
  document.writeln('  spinnerCallback_' + spinnerName + '();');
  document.writeln('  spinnerTimeout_' + spinnerName + ' = setTimeout("spinnerRepeat_' + spinnerName + '();", ' + spinnerTimeout + ');');
  document.writeln('}');

  //============================================  
  // Fonction appele quand un des boutons est    
  // relach                                      
  //============================================  

  document.writeln('function spinnerUp_' + spinnerName + '(img)');
  document.writeln('{');
  document.writeln('  var action = img.src;');
  document.writeln('  clearTimeout(spinnerTimeout_' + spinnerName + ');');
  document.writeln('  spinnerImg_' + spinnerName + ' = img;');
  document.writeln('  if ( action.indexOf("spinner_up") >= 0 )');
  document.writeln('    img.src = "' + glbSpinnerDir + '/spinner_up.gif";');
  document.writeln('  else if ( action.indexOf("spinner_down") >= 0 )');
  document.writeln('    img.src = "' + glbSpinnerDir + '/spinner_down.gif";');
  document.writeln('}');
  document.writeln('//-->');
  document.write('<');
  document.writeln('/script>');

  //============================================  
  // Cration de l'objet graphique                
  //============================================  

  document.writeln('<input type=hidden name=MIN value="' + spinnerMin + '">');
  document.writeln('<input type=hidden name=MAX value="' + spinnerMax + '">');
  document.writeln('<table border=0 cellpadding=0 cellspacing=0>');
  document.writeln('  <tr>');
  if ( spinnerPosition == 'left' )
  {
    document.writeln('    <td><img onMouseDown="spinnerDown_' + spinnerName + '(this);" onMouseUp="spinnerUp_' + spinnerName + '(this);" onMouseOut="spinnerUp_' + spinnerName + '(this);" border="0" src="' + glbSpinnerDir + '/spinner_up.gif" border="0"></td>');
    document.writeln('    <td rowspan="2"><input name="INPUT" onChange="spinnerChange_' + spinnerName + '();" size="' + spinnerWidth + '" value="' + defaultStr + '"></td>');
  }
  else
  {
    document.writeln('    <td rowspan="2"><input name="INPUT" onChange="spinnerChange_' + spinnerName + '();" size="' + spinnerWidth + '" value="' + defaultStr + '"></td>');
    document.writeln('    <td><img onMouseDown="spinnerDown_' + spinnerName + '(this);" onMouseUp="spinnerUp_' + spinnerName + '(this);" onMouseOut="spinnerUp_' + spinnerName + '(this);" border="0" src="' + glbSpinnerDir + '/spinner_up.gif" border="0"></td>');
  }
  document.writeln('  </tr>');
  document.writeln('  <tr>');
  document.writeln('    <td><img onMouseDown="spinnerDown_' + spinnerName + '(this);" onMouseUp="spinnerUp_' + spinnerName + '(this);" onMouseOut="spinnerUp_' + spinnerName + '(this);" border="0" src="' + glbSpinnerDir + '/spinner_down.gif" border="0"></td>');
  document.writeln('  </tr>');
  document.writeln('</table>');
  document.writeln('</form>');
  return false;
}

//########################################################################################  
// Fonction getSpinner
// 
// Lecture de la valeur d'un spinner
// 
// var val = getSpinner(
//    "name" , nom du spinner,
// );
// 
//########################################################################################  

function getSpinner()
{
  //============================================  
  // Test si init a t faite                     
  //============================================  

  if ( glbSpinnerDir == '' )
  {
    alert("Spinners non initialiss.\n\nAppelez la fonction initSpinner(repertoire);");
    return;
  }

  //============================================  
  // Dclaration variables                        
  //============================================  

  var spinnerName;

  //============================================  
  // Lecture arguments                            
  //============================================  

  if ( arguments[0] == "name" )
  {
    //============================================  
    // Arguments nomms                             
    //============================================  

    for (var i=0; i<arguments.length; i++) 
    {
      switch ( arguments[i] )
      {
        case "name" :
          spinnerName = arguments[++i];
          break;
        default :
          alert("getSpinner : argument non reconnu : " + arguments[i]);
          return;
          break;
      }
    }
  }
  else
  {
    //============================================  
    // Arguments positionnels
    //============================================  

    spinnerName = arguments[0];
  }

  //============================================  
  // Lecture contenu de la zone de saisie
  //============================================  

  var val = document.forms[spinnerName].INPUT.value;

  //============================================  
  // Retour  l'appelant                          
  //============================================  

  return val;
}

//########################################################################################  
// Fonction setSpinner
// 
// Ecriture de la valeur d'un spinner
// 
// var oldValue = setSpinner(
//    "name" , nom du spinner,
//    "value" , nouvelle valeur,
//    "min" , nouvelle borne minimale,
//    "max" , nouvelle borne maximale,
// );
// 
//########################################################################################  

function setSpinner()
{
  //============================================  
  // Test si init a t faite                     
  //============================================  

  if ( glbSpinnerDir == '' )
  {
    alert("Spinners non initialiss.\n\nAppelez la fonction initSpinner(repertoire);");
    return;
  }

  //============================================  
  // Dclaration variables                        
  //============================================  

  var spinnerName;
  var spinnerValue = null;
  var spinnerMin = null;
  var spinnerMax = null;

  //============================================  
  // Lecture arguments                            
  //============================================  

  if ( arguments[0] == "name" || arguments[0] == "value" || arguments[0] == "min" || arguments[0] == "max" )
  {
    //============================================  
    // Arguments nomms                             
    //============================================  

    for (var i=0; i<arguments.length; i++) 
    {
      switch ( arguments[i] )
      {
        case "name" :
          spinnerName = arguments[++i];
          break;
        case "value" :
          spinnerValue = arguments[++i];
          break;
        case "min" :
          spinnerMin = arguments[++i];
          break;
        case "max" :
          spinnerMax = arguments[++i];
          break;
        default :
          alert("setSpinner : argument non reconnu : " + arguments[i]);
          return;
          break;
      }
    }
  }
  else
  {
    //============================================  
    // Arguments positionnels
    //============================================  

    spinnerName = arguments[0];
    spinnerValue = arguments[1];
  }

  //============================================  
  // Lecture ancienne valeur                      
  //============================================  

  var old = getSpinner(spinnerName);

  if ( spinnerMin != null )
  {
    //============================================  
    // Ecriture nouvelle borne
    //============================================  

    spinnerMin = parseFloat(spinnerMin);
    document.forms[spinnerName].MIN.value = spinnerMin;

    //============================================  
    // Positionnement valeur si hors bornes
    //============================================  

    if ( old < spinnerMin )
    {
      setSpinner("name", spinnerName,
                 "value", spinnerMin);
    }
  }

  if ( spinnerMax != null )
  {
    //============================================  
    // Ecriture nouvelle borne
    //============================================  

    spinnerMax = parseFloat(spinnerMax);
    document.forms[spinnerName].MAX.value = spinnerMax;

    //============================================  
    // Positionnement valeur si hors bornes
    //============================================  

    if ( old > spinnerMax )
    {
      setSpinner("name", spinnerName,
                 "value", spinnerMax);
    }
  }

  if ( spinnerValue != null )
  {
    //============================================  
    // Test si la nouvelle valeur est entre         
    // les bornes                                   
    //============================================  

    var min = document.forms[spinnerName].MIN.value;
    var max = document.forms[spinnerName].MAX.value;

    spinnerValue = parseFloat(spinnerValue);

    if ( spinnerValue < min || spinnerValue > max )
    {
      alert("setSpinner(\"name\", \"" + spinnerName + "\" , \"value\", " + spinnerValue + ") : la valeur est hors des bornes autorises (" + min + "  " + max + ")");
      return '';
    }

    //============================================  
    // Ecriture dans la zone de texte               
    //============================================  

    document.forms[spinnerName].INPUT.value = spinnerValue;
  }

  //============================================  
  // Retour  l'appelant                          
  //============================================  

  return old;
}

